//********************************************************
// Syzygy is licensed under the BSD license v2
// see the file SZG_CREDITS for details
//********************************************************
#include "arPrecompiled.h"
#include "arMasterSlaveFramework.h"
#include "vssClient.h"   //VSS
#include "arMath.h"//
#include "arGlut.h"
#ifndef AR_USE_WIN_32
#include <sys/types.h>
#include <signal.h>
#include <iostream>
#endif

#include <list>

float a = 0;
float g = 0;
const float eraserRadius = 5. / 12.;

class stroke {
public:
	int iColor;
	list <arVector3> l;
	
	void clear()
    { iColor = -1; l.clear(); }
	void append(const arVector3& v);
	stroke()
    { clear(); }
};

class superman {
public:
	int iColor;
	list <arVector3> ll;
	
	void clear()
	{iColor =-1; ll.clear();}
	void append(const arVector3& vv);
	superman()
	{ clear(); }
};

class yellow {
public:
	int iColor;
	list <arVector3> y;
	
	void clear()
	{iColor =-1; y.clear();}
	void append(const arVector3& yy);
	yellow()
	{ clear(); }
};

class green {
public:
	int iColor;
	list <arVector3> g;
	
	void clear()
	{iColor =-1; g.clear();}
	void append(const arVector3& gg);
	green()
	{ clear(); }
};

class blue {
public:
	int iColor;
	list <arVector3> b;
	
	void clear()
	{iColor =-1; b.clear();}
	void append(const arVector3& bb);
	blue()
	{ clear(); }
};

class indigo {
public:
	int iColor;
	list <arVector3> ind;
	
	void clear()
	{iColor =-1; ind.clear();}
	void append(const arVector3& indind);
	indigo()
	{ clear(); }
};

class violet {
public:
	int iColor;
	list <arVector3> vio;
	
	void clear()
	{iColor =-1; vio.clear();}
	void append(const arVector3& viovio);
	violet()
	{ clear(); }
};

void stroke::append(const arVector3& v)
{
	if (!l.empty()) {
		const float resolution = 0.75 / 12.;
		const arVector3 previous = l.back();
		const float distance = (v - previous).magnitude();
		if (distance < resolution)
			return;
		
		if (distance > eraserRadius) {
			const arVector3 diff = v - previous;
			const float steps = ceil(distance / (eraserRadius * .8));
			const float dt = 1. / steps;
			for (float t=dt; t<1.; t += dt) {
				const arVector3 vLerp = previous + (t * diff);
				if ((vLerp - v).magnitude() > resolution) {
					l.push_back(vLerp);
				}
			}
		}
	}
	l.push_back(v);
}

void superman::append(const arVector3& vv)
{
	if (!ll.empty()) {
		const float resolutions = 0.75 / 12.;
		const arVector3 previouss = ll.back();
		const float distancee = (vv - previouss).magnitude();
		if (distancee < resolutions)
			return;
		
		if (distancee > eraserRadius) {
			const arVector3 difff = vv - previouss;
			const float stepss = ceil(distancee / (eraserRadius * .8)); 
			const float dt = 1. / stepss;
			for (float t=dt; t<1.; t += dt) {
				const arVector3 vvLerpp = previouss + (t * difff);
				if ((vvLerpp - vv).magnitude() > resolutions) {
					ll.push_back(vvLerpp);
				}
			}
		}
	}
	ll.push_back(vv); 
}

void yellow::append(const arVector3& yy)
{
	if (!y.empty()) {
		const float resolutiony = 0.75 / 12.;
		const arVector3 previousy = y.back();
		const float distancey = (yy - previousy).magnitude();
		if (distancey < resolutiony)
			return;
		
		if (distancey > eraserRadius) {
			const arVector3 diffy = yy - previousy;
			const float stepsy = ceil(distancey / (eraserRadius * .8));
			const float dt = 1. / stepsy;
			for (float t=dt; t<1.; t += dt) {
				const arVector3 yyLerpp = previousy + (t * diffy);
				if ((yyLerpp - yy).magnitude() > resolutiony) {
					y.push_back(yyLerpp);
				}
			}
		}
	}
	y.push_back(yy);
}

void green::append(const arVector3& gg)
{
	if (!g.empty()) {
		const float resolutiong = 0.75 / 12.;
		const arVector3 previousg = g.back();
		const float distanceg = (gg - previousg).magnitude();
		if (distanceg < resolutiong)
			return;
		
		if (distanceg > eraserRadius) {
			const arVector3 diffg = gg - previousg;
			const float stepsg = ceil(distanceg / (eraserRadius * .8));
			const float dt = 1. / stepsg;
			for (float t=dt; t<1.; t += dt) {
				const arVector3 ggLerpp = previousg + (t * diffg);
				if ((ggLerpp - gg).magnitude() > resolutiong) {
					g.push_back(ggLerpp);
				}
			}
		}
	}
	g.push_back(gg);
}

void blue::append(const arVector3& bb)
{
	if (!b.empty()) {
		const float resolutionb = 0.75 / 12.;
		const arVector3 previousb = b.back();
		const float distanceb = (bb - previousb).magnitude();
		if (distanceb < resolutionb)
			return;
		
		if (distanceb > eraserRadius) {
			const arVector3 diffb = bb - previousb;
			const float stepsb = ceil(distanceb / (eraserRadius * .8));
			const float dt = 1. / stepsb;
			for (float t=dt; t<1.; t += dt) {
				const arVector3 bbLerpp = previousb + (t * diffb);
				if ((bbLerpp - bb).magnitude() > resolutionb) {
					b.push_back(bbLerpp);
				}
			}
		}
	}
	b.push_back(bb);
}

void indigo::append(const arVector3& indind)
{
	if (!ind.empty()) {
		const float resolutionind = 0.75 / 12.;
		const arVector3 previousind = ind.back();
		const float distanceind = (indind - previousind).magnitude();
		if (distanceind < resolutionind)
			return;
		
		if (distanceind > eraserRadius) {
			const arVector3 diffind = indind - previousind;
			const float stepsind = ceil(distanceind / (eraserRadius * .8));
			const float dt = 1. / stepsind;
			for (float t=dt; t<1.; t += dt) {
				const arVector3 indindLerpp = previousind + (t * diffind);
				if ((indindLerpp - indind).magnitude() > resolutionind) {
					ind.push_back(indindLerpp);
				}
			}
		}
	}
	ind.push_back(indind); 
}

void violet::append(const arVector3& viovio)
{
	if (!vio.empty()) {
		const float resolutionvio = 0.75 / 12.;
		const arVector3 previousvio = vio.back();
		const float distancevio = (viovio - previousvio).magnitude();
		if (distancevio < resolutionvio)
			return;
		
		if (distancevio > eraserRadius) {
			const arVector3 diffvio = viovio - previousvio;
			const float stepsvio = ceil(distancevio / (eraserRadius * .8));
			const float dt = 1. / stepsvio;
			for (float t=dt; t<1.; t += dt) {
				const arVector3 viovioLerpp = previousvio + (t * diffvio);
				if ((viovioLerpp - viovio).magnitude() > resolutionvio) {
					vio.push_back(viovioLerpp);
				}
			}
		}
	}
	vio.push_back(viovio);
}


list<stroke> strokes;
list<stroke> fragments;
list<superman> batman;
list<superman> riddler;
list<yellow> lineY;
list<yellow> fragmentY;
list<green> lineG;
list<green> fragmentG;
list<blue> lineB;
list<blue> fragmentB;
list<indigo> lineInd;
list<indigo> fragmentInd;
list<violet> lineV;
list<violet> fragmentV;
arLock lockDraw;
stroke sCur;
superman tCur;
yellow yCur;
green gCur;
blue bCur;
indigo indCur;
violet vioCur;
typedef list <arVector3>::const_iterator citer;
typedef list <arVector3>::iterator iter;


void EraseRibbon(stroke* s, const arVector3& v)
{
Lagain:
	list <arVector3>& l = s->l;
	
	int i = 0;
	for (iter ii = l.begin(); ii != l.end(); ++ii,++i) {
		if ((*ii - v).magnitude() < eraserRadius) {
			if (ii == l.begin()) {
				l.erase(ii);
				goto Lagain;
			}
			iter iDel = ii++;
			l.erase(iDel);
			if (ii == l.end()) {
				break;
			}
			
			stroke *t = new stroke;
			t->iColor = s->iColor;
			
			t->l.splice(t->l.begin(), l, ii, l.end());
			
			if (i <= 3 ) {
				l.clear();
			}
			
			if (t->l.size() <= 3) {
				delete t;
				break;
			}
			
			fragments.push_back(*t);
			s = t;
			goto Lagain;
		}
	}
}

void EraseRibbonO(superman* s, const arVector3& vv) 
{
Lagain:
	list <arVector3>& ll = s->ll;
	
	int i = 0;
	for (iter ii = ll.begin(); ii != ll.end(); ++ii,++i) {
		if ((*ii - vv).magnitude() < eraserRadius) {
			if (ii == ll.begin()) {
				ll.erase(ii);
				goto Lagain;
			}
			iter iDel = ii++;
			ll.erase(iDel);
			if (ii == ll.end()) {
				break;
			}
			
			superman *t = new superman;
			t->iColor = s->iColor;
			
			t->ll.splice(t->ll.begin(), ll, ii, ll.end());
			
			if (i <= 3 ) {
				ll.clear();
			}
			
			if (t->ll.size() <= 3) {
				delete t;
				break;
			}
			
			riddler.push_back(*t);
			s = t;
			goto Lagain;
		}
	}
}

void EraseRibbonY(yellow* s, const arVector3& yy)
{
Lagain:
	list <arVector3>& y = s->y;
	
	int i = 0;
	for (iter ii = y.begin(); ii != y.end(); ++ii,++i) {
		if ((*ii - yy).magnitude() < eraserRadius) {
			if (ii == y.begin()) {
				y.erase(ii);
				goto Lagain;
			}
			iter iDel = ii++;
			y.erase(iDel);
			if (ii == y.end()) {
				break;
			}
			
			yellow *t = new yellow;
			t->iColor = s->iColor;
			
			t->y.splice(t->y.begin(), y, ii, y.end());
			
			if (i <= 3 ) {
				y.clear();
			}
			
			if (t->y.size() <= 3) {
				delete t;
				break;
			}
			
			fragmentY.push_back(*t);
			s = t;
			goto Lagain;
		}
	}
}


void EraseRibbonG(green* s, const arVector3& gg)
{
Lagain:
	list <arVector3>& g = s->g;
	
	int i = 0;
	for (iter ii = g.begin(); ii != g.end(); ++ii,++i) {
		if ((*ii - gg).magnitude() < eraserRadius) {
			if (ii == g.begin()) {
				g.erase(ii);
				goto Lagain;
			}
			iter iDel = ii++;
			g.erase(iDel);
			if (ii == g.end()) {
				break;
			}
			
			green *t = new green;
			t->iColor = s->iColor;
			
			t->g.splice(t->g.begin(), g, ii, g.end());
			
			if (i <= 3 ) {
				g.clear();
			}
			
			if (t->g.size() <= 3) {
				delete t;
				break;
			}
			
			fragmentG.push_back(*t);
			s = t;
			goto Lagain;
		}
	}
}


void EraseRibbonB(blue* s, const arVector3& bb)
{
Lagain:
	list <arVector3>& b = s->b;
	
	int i = 0;
	for (iter ii = b.begin(); ii != b.end(); ++ii,++i) {
		if ((*ii - bb).magnitude() < eraserRadius) {
			if (ii == b.begin()) {
				b.erase(ii);
				goto Lagain;
			}
			iter iDel = ii++;
			b.erase(iDel);
			if (ii == b.end()) {
				break;
			}
			
			blue *t = new blue;
			t->iColor = s->iColor; 
			
			t->b.splice(t->b.begin(), b, ii, b.end());
			
			if (i <= 3 ) {
				
				b.clear();
			}
			
			if (t->b.size() <= 3) {
				delete t;
				break;
			}
			
			fragmentB.push_back(*t);
			s = t;
			goto Lagain;
		}
	}
}



void EraseRibbonInd(indigo* s, const arVector3& indind)
{
Lagain:
	list <arVector3>& ind = s->ind;
	
	int i = 0;
	for (iter ii = ind.begin(); ii != ind.end(); ++ii,++i) {
		if ((*ii - indind).magnitude() < eraserRadius) {
			if (ii == ind.begin()) {
				ind.erase(ii);
				goto Lagain;
			}
			iter iDel = ii++;
			ind.erase(iDel);
			if (ii == ind.end()) {
				break;
			}
			
			indigo *t = new indigo;
			t->iColor = s->iColor;
			
			t->ind.splice(t->ind.begin(), ind, ii, ind.end());
			
			if (i <= 3 ) {
				ind.clear();
			}
			
			if (t->ind.size() <= 3) {
				delete t;
				break;
			}
			
			fragmentInd.push_back(*t);
			s = t;
			goto Lagain;
		}
	}
}


void EraseRibbonV(violet* s, const arVector3& viovio)
{
Lagain:
	list <arVector3>& vio = s->vio;
	
	int i = 0;
	for (iter ii = vio.begin(); ii != vio.end(); ++ii,++i) {
		if ((*ii - viovio).magnitude() < eraserRadius) {
			if (ii == vio.begin()) {
				vio.erase(ii);
				goto Lagain;
			}
			iter iDel = ii++;
			vio.erase(iDel);
			if (ii == vio.end()) {
				break;
			}
			
			violet *t = new violet;
			t->iColor = s->iColor; 
			
			t->vio.splice(t->vio.begin(), vio, ii, vio.end());
			
			if (i <= 3 ) {
				vio.clear();
			}
			
			if (t->vio.size() <= 3) {
				delete t;
				break;
			}
			
			fragmentV.push_back(*t);
			s = t;
			goto Lagain;
		}
	}
}


// Ribbon drawing routine, originally by Chris Hartman 6/1994
// Modified and encapsulated by Camille Goudeseune 7/1994 - 4/1996
// Modified some more and ported to Syzygy by Camille Goudeseune 4/2003
// Modified a little by Chris Bisom Nov./Dec. 2009


//RED RIBBON
//////////////

void DrawRibbon(const list <arVector3>& PT, float zWidth, int wLowpass)
{
	const int cpt = PT.size();
	if (cpt < 3)
		return;
	if (wLowpass <= 0)
		return;
	
	arVector3 bnPrev(0,0,1);
	arVector3 prev1, prev2;
    glDisable(GL_LIGHTING);
	glPointSize(0);
	glLineWidth(g);
	glBegin(GL_LINE_STRIP);
	
	citer ii = PT.begin(); ++ii;
	for (int i=0; i<cpt-1; ++i, ++ii)
    {
		//int jPrev, jNext;
		//citer iiPrev = ii;
		const arVector3 PTcur = *ii;
		//for (jPrev=0; jPrev<wLowpass && iiPrev != PT.begin(); ++jPrev) //2nd condition (!=) not important
		//	--iiPrev;
		//citer iiNext = ii; 
		//citer iiMax = PT.end();  --iiMax;
		//const arVector3 PTpt = PTcur;
		//for (jNext=0; jNext<wLowpass && iiNext != iiMax; ++jNext)
		//	++iiNext; 
		//if (jPrev == 0 && jNext == 0) {
		//	cerr << "ribbons: internal error.\n";
		//	break;}
		//const arVector3 PTprev = jPrev==0 ? (*ii + *ii - *iiNext) : *iiPrev; //if jPrev is 0, it sets up the PTprev to the value stored at ii + the value stored at ii - the value stored at the next point
		//const arVector3 PTnext = jNext==0 ? (*ii + *ii - *iiPrev) : *iiNext;
		
		//arVector3 bn = (PTprev-PTcur) * (PTnext+PTcur);
		//LAgain:
		//float length = bn.magnitude();
		//if (length <= 0.02)
		//{
		//	if (i < 3)
		//		continue;
		//	bn = bnPrev;
		//	goto LAgain;
		//}
		
		//arVector3 nn = bn * (PTnext - PTprev);
		//bn *= zWidth / length;
		//bnPrev = bn;
		//length = nn.magnitude();
		//if (length >= .01) {
		//	nn /= length;
		//	glNormal3fv(nn.v); 
		//}
		
		//const arVector3 tmp1 = PTcur + bn;
		//const arVector3 tmp2 = PTcur - bn;
		//const arVector3 k = prev1;
		//const float distA = (prev1 - tmp1).magnitude() + (prev2 - tmp2).magnitude();
		//const float distB = (prev1 - tmp2).magnitude() + (prev2 - tmp1).magnitude();
		//if (distA < distB)
		//{
		//	prev1 = tmp1;
		//	prev2 = tmp2;
		//}
		//else
		//{
		//	prev1 = tmp2;
		//	prev2 = tmp1;
		//}

		glShadeModel(GL_SMOOTH);
		glColor3f(1.,0,0);
        glVertex3fv(PTcur.v);
		
    }
	
	glEnd();
	
}

//ORANGE RIBBON
//////////////
void DrawRibbons(const list <arVector3>& PTT, float zWidth, int wLowpass)
{
	const int cpt = PTT.size();
	if (cpt < 3)
		return;
	if (wLowpass <= 0)
		return;
	
	arVector3 bnPrevv(0,0,1);
	arVector3 prev11, prev22;
	glDisable(GL_LIGHTING);
	glPointSize(9);
	glLineWidth(g);
	glBegin(GL_LINE_STRIP);
	citer ii = PTT.begin(); ++ii;
	for (int i=0; i<cpt-1; ++i, ++ii) 
	{
		int jjPrev, jjNext;
		citer iiPrev = ii;
		const arVector3 PTTcur = *ii; 
		for (jjPrev=0; jjPrev<wLowpass && iiPrev != PTT.begin(); ++jjPrev)
			--iiPrev; 
		citer iiNext = ii;
		citer iiMax = PTT.end();  --iiMax;
		const arVector3 PTTpt = PTTcur;
		for (jjNext=0; jjNext<wLowpass && iiNext != iiMax; ++jjNext)
			++iiNext; 
		if (jjPrev == 0 && jjNext == 0) {
			cerr << "ribbons: internal error.\n";
			break;
		}
		const arVector3 PTTprev = jjPrev==0 ? (*ii + *ii - *iiNext) : *iiPrev; 
		const arVector3 PTTnext = jjNext==0 ? (*ii + *ii - *iiPrev) : *iiNext;
		
		arVector3 bn = (PTTprev-PTTcur) * (PTTnext+PTTcur);
	LAgain:
		float length = bn.magnitude();
		if (length <= 0.02)
		{
			if (i < 3)
				continue;
			bn = bnPrevv;
			goto LAgain;
		}
		
		arVector3 nnn = bn * (PTTnext - PTTprev);
		bn *= zWidth / length;
		bnPrevv = bn;
		length = nnn.magnitude();
		if (length >= .01) {
			nnn /= length;
			glNormal3fv(nnn.v);
		}
		
		const arVector3 tmp11 = PTTcur + bn;
		const arVector3 tmp22 = PTTcur - bn;
		const arVector3 k = prev11;
		const float distA = (prev11 - tmp11).magnitude() + (prev22 - tmp22).magnitude();
		const float distB = (prev11 - tmp22).magnitude() + (prev22 - tmp11).magnitude();
		if (distA < distB)
		{
			prev11 = tmp11;
			prev22 = tmp22;
		}
		else
		{
			prev11 = tmp22;
			prev22 = tmp11;
		}
		glShadeModel(GL_SMOOTH);
		glColor3f(1.,.5,0);
		glVertex3fv(PTTcur.v);
		
	}
	
	glEnd();
	
}






//Yellow RIBBON
//////////////
void DrawYellowR(const list <arVector3>& Y, float zWidth, int wLowpass)
{
	const int cpt = Y.size();
	if (cpt < 3)
		return;
	if (wLowpass <= 0)
		return;
	
	arVector3 bnPrevY(0,0,1);
	arVector3 prev1Y, prev2Y;
	glDisable(GL_LIGHTING);
	glPointSize(9);
	glLineWidth(g);
	glBegin(GL_LINE_STRIP);
	
	citer ii = Y.begin(); ++ii;
	for (int i=0; i<cpt-1; ++i, ++ii)  
	{
		int jYPrev, jYNext;
		citer iiPrev = ii;
		
		const arVector3 Ycur = *ii; 
		for (jYPrev=0; jYPrev<wLowpass && iiPrev != Y.begin(); ++jYPrev) 
			--iiPrev; 
		citer iiNext = ii; 
		citer iiMax = Y.end();  --iiMax;
		const arVector3 Ypt = Ycur;
		for (jYNext=0; jYNext<wLowpass && iiNext != iiMax; ++jYNext)
			++iiNext; 
		if (jYPrev == 0 && jYNext == 0) {
			cerr << "ribbons: internal error.\n";
			break;
		}
		const arVector3 Yprev = jYPrev==0 ? (*ii + *ii - *iiNext) : *iiPrev; 
		const arVector3 Ynext = jYNext==0 ? (*ii + *ii - *iiPrev) : *iiNext;
		
		arVector3 bn = (Yprev-Ycur) * (Ynext+Ycur);
	LAgain:
		float length = bn.magnitude();
		if (length <= 0.02)
		{
			if (i < 3)
				continue;
			bn = bnPrevY;
			goto LAgain;
		}
		
		arVector3 nY = bn * (Ynext - Yprev);
		bn *= zWidth / length;
		bnPrevY = bn;
		length = nY.magnitude();
		if (length >= .01) {
			nY /= length;
			glNormal3fv(nY.v); 
		}
		
		const arVector3 tmp1Y = Ycur + bn;
		const arVector3 tmp2Y = Ycur - bn;
		const arVector3 k = prev1Y;
		const float distA = (prev1Y - tmp1Y).magnitude() + (prev2Y - tmp2Y).magnitude();
		const float distB = (prev1Y - tmp2Y).magnitude() + (prev2Y - tmp1Y).magnitude();
		if (distA < distB)
		{
			prev1Y = tmp1Y;
			prev2Y = tmp2Y;
		}
		else
		{
			prev1Y = tmp2Y;
			prev2Y = tmp1Y;
		}
		glShadeModel(GL_SMOOTH);
		glColor3f(1.,1.,0);
		glVertex3fv(Ycur.v);
		
	}
	
	glEnd();
	
}


//Draw Green Ribbon
void DrawGreenR(const list <arVector3>& G, float zWidth, int wLowpass)
{
	const int cpt = G.size();
	if (cpt < 3)
		return;
	if (wLowpass <= 0)
		return;
	
	arVector3 bnPrevG(0,0,1);
	arVector3 prev1G, prev2G;
	glDisable(GL_LIGHTING);
	glPointSize(9);
	glLineWidth(g);
	glBegin(GL_LINE_STRIP);
	citer ii = G.begin(); ++ii;
	for (int i=0; i<cpt-1; ++i, ++ii)
	{
		int GPrev, GNext;
		citer iiPrev = ii;
		const arVector3 Gcur = *ii;
		for (GPrev=0; GPrev<wLowpass && iiPrev != G.begin(); ++GPrev) 
			--iiPrev;
		citer iiNext = ii;
		citer iiMax = G.end();  --iiMax;
		const arVector3 Gpt = Gcur;
		for (GNext=0; GNext<wLowpass && iiNext != iiMax; ++GNext)
			++iiNext;
		if (GPrev == 0 && GNext == 0) {
			cerr << "ribbons: internal error.\n";
			break;
		}
		const arVector3 Gprev = GPrev==0 ? (*ii + *ii - *iiNext) : *iiPrev; 
		const arVector3 Gnext = GNext==0 ? (*ii + *ii - *iiPrev) : *iiNext;
		
		arVector3 bn = (Gprev-Gcur) * (Gnext+Gcur);
	LAgain:
		float length = bn.magnitude();
		if (length <= 0.02)
		{
			if (i < 3)
				continue;
			bn = bnPrevG;
			goto LAgain;
		}
		
		arVector3 nG = bn * (Gnext - Gprev);
		bn *= zWidth / length;
		bnPrevG = bn;
		length = nG.magnitude();
		if (length >= .01) {
			nG /= length;
			glNormal3fv(nG.v);
		}
		
		const arVector3 tmp1G = Gcur + bn;
		const arVector3 tmp2G = Gcur - bn;
		const arVector3 k = prev1G;
		const float distA = (prev1G - tmp1G).magnitude() + (prev2G - tmp2G).magnitude();
		const float distB = (prev1G - tmp2G).magnitude() + (prev2G - tmp1G).magnitude();
		if (distA < distB)
		{
			prev1G = tmp1G;
			prev2G = tmp2G;
		}
		else
		{
			prev1G = tmp2G;
			prev2G = tmp1G;
		}
		glShadeModel(GL_SMOOTH);
		glColor3f(0,1.,0);
		glVertex3fv(Gcur.v);
		
	}
	
	glEnd();
	
}



//Draw Blue Ribbon
void DrawBlueR(const list <arVector3>& B, float zWidth, int wLowpass)
{
	const int cpt = B.size();
	if (cpt < 3)
		return;
	if (wLowpass <= 0)
		return;
	
	arVector3 bnPrevB(0,0,1); 
	arVector3 prev1B, prev2B; 
	
	glDisable(GL_LIGHTING);
	glPointSize(9);
	glLineWidth(g);
	glBegin(GL_LINE_STRIP);
	
	citer ii = B.begin(); ++ii;
	for (int i=0; i<cpt-1; ++i, ++ii)
	{
		int BPrev, BNext;
		citer iiPrev = ii;
		const arVector3 Bcur = *ii;
		for (BPrev=0; BPrev<wLowpass && iiPrev != B.begin(); ++BPrev)
			--iiPrev; 
		citer iiNext = ii;
		citer iiMax = B.end();  --iiMax;
		const arVector3 Bpt = Bcur;
		for (BNext=0; BNext<wLowpass && iiNext != iiMax; ++BNext)
			++iiNext;
		if (BPrev == 0 && BNext == 0) {
			cerr << "ribbons: internal error.\n";
			break;
		}
		const arVector3 Bprev = BPrev==0 ? (*ii + *ii - *iiNext) : *iiPrev; 
		const arVector3 Bnext = BNext==0 ? (*ii + *ii - *iiPrev) : *iiNext;
		
		arVector3 bn = (Bprev-Bcur) * (Bnext+Bcur);
	LAgain:
		float length = bn.magnitude();
		if (length <= 0.02)
		{
			if (i < 3)
				continue;
			bn = bnPrevB;
			goto LAgain;
		}
		
		arVector3 nB = bn * (Bnext - Bprev);
		bn *= zWidth / length;
		bnPrevB = bn;
		length = nB.magnitude();
		if (length >= .01) {
			nB /= length;
			glNormal3fv(nB.v);
		}
		
		const arVector3 tmp1B = Bcur + bn;
		const arVector3 tmp2B = Bcur - bn;
		const arVector3 k = prev1B;
		const float distA = (prev1B - tmp1B).magnitude() + (prev2B - tmp2B).magnitude();
		const float distB = (prev1B - tmp2B).magnitude() + (prev2B - tmp1B).magnitude();
		if (distA < distB)
		{
			prev1B = tmp1B;
			prev2B = tmp2B;
		}
		else
		{
			prev1B = tmp2B;
			prev2B = tmp1B;
		}
		
		glShadeModel(GL_SMOOTH);
		glColor3f(0,0,1);
		glVertex3fv(Bcur.v);
		
	}
	
	glEnd();
	
}


//Draw Indigo Ribbon
void DrawIndigoR(const list <arVector3>& Ind, float zWidth, int wLowpass)
{
	const int cpt = Ind.size();
	if (cpt < 3)
		return;
	if (wLowpass <= 0)
		return;
	
	arVector3 bnPrevInd(0,0,1);
	arVector3 prev1Ind, prev2Ind;
	glDisable(GL_LIGHTING);
	glPointSize(9);
	glLineWidth(g);
	glBegin(GL_LINE_STRIP);
	citer ii = Ind.begin(); ++ii;
	for (int i=0; i<cpt-1; ++i, ++ii)
	{
		int IndPrev, IndNext;
		citer iiPrev = ii;
		const arVector3 Indcur = *ii; 
		for (IndPrev=0; IndPrev<wLowpass && iiPrev != Ind.begin(); +IndPrev)
			--iiPrev; 
		citer iiNext = ii;
		citer iiMax = Ind.end();  --iiMax;
		const arVector3 Indpt = Indcur;
		for (IndNext=0; IndNext<wLowpass && iiNext != iiMax; ++IndNext)
			++iiNext;
		if (IndPrev == 1 && IndNext == 0) {
			cerr << "ribbons: internal error.\n";
			break;
		}
		
		const arVector3 Indprev = IndPrev==0 ? (*ii + *ii - *iiNext) : *iiPrev; 
		const arVector3 Indnext = IndNext==0 ? (*ii + *ii - *iiPrev) : *iiNext;
		
		arVector3 bn = (Indprev-Indcur) * (Indnext+Indcur);
	LAgain:
		float length = bn.magnitude();
		if (length <= 0.02)
		{
			if (i < 3)
				continue;
			bn = bnPrevInd;
			goto LAgain;
		}
		
		arVector3 nInd = bn * (Indnext - Indprev);
		bn *= zWidth / length;
		bnPrevInd = bn;
		length = nInd.magnitude();
		if (length >= .01) {
			nInd /= length;
			glNormal3fv(nInd.v);
		}
		
		const arVector3 tmp1Ind = Indcur + bn;
		const arVector3 tmp2Ind = Indcur - bn;
		const arVector3 k = prev1Ind;
		const float distA = (prev1Ind - tmp1Ind).magnitude() + (prev2Ind - tmp2Ind).magnitude();
		const float distB = (prev1Ind - tmp2Ind).magnitude() + (prev2Ind - tmp1Ind).magnitude();
		if (distA < distB)
		{
			prev1Ind = tmp1Ind;
			prev2Ind = tmp2Ind;
		}
		else
		{
			prev1Ind = tmp2Ind;
			prev2Ind = tmp1Ind;
		}
		glShadeModel(GL_SMOOTH);
		glColor3f(0,.5,.5);
		glVertex3fv(Indcur.v);
		
	}
	
	glEnd();
}


//Draw Violet Ribbon
void DrawVioletR(const list <arVector3>& Vio, float zWidth, int wLowpass)
{
	const int cpt = Vio.size();
	if (cpt < 3)
		return;
	if (wLowpass <= 0)
		return;
	
	arVector3 bnPrevVio(0,0,1);
	arVector3 prev1Vio, prev2Vio;
	
	glDisable(GL_LIGHTING);
	glPointSize(9);
	glLineWidth(g);
	glBegin(GL_LINE_STRIP);
	
	citer ii = Vio.begin(); ++ii;
	for (int i=0; i<cpt-1; ++i, ++ii)
		
	{

		const arVector3 Viocur = *ii;
		glShadeModel(GL_SMOOTH);
		glColor3f(.5,0,.5);
		glVertex3fv(Viocur.v);
		
	}
	
	glEnd();
	
}




bool init(arMasterSlaveFramework& fw, arSZGClient&){
    if(fw.getMaster()){
       BeginSoundServer();
       // This works as of 2010 Mar 2: AUDinit("windparam2.aud"); /////////////////////////////////////////////////
       //AUDinit("fm2010Mar2.aud");
       AUDinit("windparam.aud");
    }
  return true;
}


#ifdef UNUSED
struct onepoint : public unary_function<const arVector3&, void>
{
    onepoint() { glBegin(GL_LINE_STRIP); }
    void operator()(const arVector3& v) { glVertex3fv(v.v); }
    ~onepoint() { glEnd(); }
};
struct drawStrokeAsLine : public unary_function<stroke, void>
{
    void operator()(const stroke& s) { for_each(s.l.begin(), s.l.end(), onepoint()); }
}
#endif


struct drawStroke : public unary_function<stroke, void>
{
	void operator()(const stroke& s) { DrawRibbon(s.l, 0.2, 12); }
};

struct drawStrokes : public unary_function<superman, void>
{
	void operator()(const superman& tt) { DrawRibbons(tt.ll, 0.2, 12); }
};

struct drawStrokeY : public unary_function<yellow, void>
{
	void operator()(const yellow& yy) { DrawYellowR(yy.y, 0.2, 12); }
};

struct drawStrokeG : public unary_function<green, void>
{
	void operator()(const green& gg) { DrawGreenR(gg.g, 0.2, 12); }
};

struct drawStrokeB : public unary_function<blue, void>
{
	void operator()(const blue& bb) { DrawBlueR(bb.b, 0.2, 12); }
};

struct drawStrokeInd : public unary_function<indigo, void>
{
	void operator()(const indigo& indind) { DrawIndigoR(indind.ind, 0.2, 12); }
};

struct drawStrokeVio : public unary_function<violet, void>
{
	void operator()(const violet& viovio) { DrawVioletR(viovio.vio, 0.2, 12); }
};

struct eraseStroke : public unary_function<stroke, void>
{
	const arVector3& _v;
	eraseStroke(const arVector3& v) : _v(v) {}
	void operator()(stroke& s) { EraseRibbon(&s, _v); }
};

struct eraseStrokeO : public unary_function<superman, void>
{
	const arVector3& _vv;
	eraseStrokeO(const arVector3& vv) : _vv(vv) {}
	void operator()(superman& s) { EraseRibbonO(&s, _vv); }
};

struct eraseStrokeY : public unary_function<yellow, void>
{
	const arVector3& _yy;
	eraseStrokeY(const arVector3& yy) : _yy(yy) {}
	void operator()(yellow& s) { EraseRibbonY(&s, _yy); }
};

struct eraseStrokeG : public unary_function<green, void>
{
	const arVector3& _gg;
	eraseStrokeG(const arVector3& gg) : _gg(gg) {}
	void operator()(green& s) { EraseRibbonG(&s, _gg); }
};

struct eraseStrokeB : public unary_function<blue, void>
{
	const arVector3& _bb;
	eraseStrokeB(const arVector3& bb) : _bb(bb) {}
	void operator()(blue& s) { EraseRibbonB(&s, _bb); }
};

struct eraseStrokeInd : public unary_function<indigo, void>
{
	const arVector3& _indind;
	eraseStrokeInd(const arVector3& indind) : _indind(indind) {}
	void operator()(indigo& s) { EraseRibbonInd(&s, _indind); }
};

struct eraseStrokeV : public unary_function<violet, void>
{
	const arVector3& _viovio;
	eraseStrokeV(const arVector3& viovio) : _viovio(viovio) {}
	void operator()(violet& s) { EraseRibbonV(&s, _viovio); }
};

void drawStars()
{
	int p;
	glDisable(GL_LIGHTING);
	glEnable(GL_POINT_SMOOTH);
	p = rand() % 100 + 1;
	glColor3f(.01,.01,.01);
	srand(42);
	glBegin(GL_POINTS);
	for (int i=0; i<10000; ++i) {
		if (i % 100 == 0) {
			glEnd();
			glPointSize(1 + i/300.);
			glBegin(GL_POINTS);
		}
		const float x = (rand() % 10000) / 10000. * 100. - 50;
		const float y = (rand() % 10000) / 10000. * 100. - 50;
		const float z = (rand() % 10000) / 10000. * 100. - 50;
		if (fabs(x)<20. && fabs(z)<20. && y>-15. && y<25.)
			continue;
		glVertex3f(x, y, z);
	}
	glEnd();
	
	glDisable(GL_POINT_SMOOTH);
	glEnable(GL_LIGHTING);
}

void drawSculpture()
{
	glPushMatrix();
    lockDraw.lock();
    for_each(strokes.begin(), strokes.end(), drawStroke());
    lockDraw.unlock();
    static drawStroke tmp; tmp(sCur); //this shows the current ribbon: that is, without this line, the ribbon is not visible until the mouse is relaxed
	
	glPopMatrix();
	
}

void drawSculptures()
{
	
	glPushMatrix();
    lockDraw.lock();
    for_each(batman.begin(), batman.end(), drawStrokes());
    lockDraw.unlock();
    static drawStrokes tmp; tmp(tCur);
	
	glPopMatrix();
	
}

void drawSculptureY()
{
	
	glPushMatrix();
    lockDraw.lock();
    for_each(lineY.begin(), lineY.end(), drawStrokeY());
    lockDraw.unlock();
    static drawStrokeY tmp; tmp(yCur);
	
	glPopMatrix();
	
}


void drawSculptureG()
{
	
	glPushMatrix();
    lockDraw.lock();
    for_each(lineG.begin(), lineG.end(), drawStrokeG());
    lockDraw.unlock();
    static drawStrokeG tmp; tmp(gCur);
	
	glPopMatrix();
	
}


void drawSculptureB()
{
	
	glPushMatrix();
    lockDraw.lock();
    for_each(lineB.begin(), lineB.end(), drawStrokeB());
    lockDraw.unlock();
    static drawStrokeB tmp; tmp(bCur);
	
	glPopMatrix();
	
}

void drawSculptureInd()
{
	
	glPushMatrix();
    lockDraw.lock();
    for_each(lineInd.begin(), lineInd.end(), drawStrokeInd());
    lockDraw.unlock();
    static drawStrokeInd tmp; tmp(indCur);
	
	glPopMatrix();
	
}

void drawSculptureVio()
{
	
	glPushMatrix();
    lockDraw.lock();
    for_each(lineV.begin(), lineV.end(), drawStrokeVio());
    lockDraw.unlock();
    static drawStrokeVio tmp; tmp(vioCur);
	
	glPopMatrix();
	
}

struct emptyStroke : public unary_function<stroke, void>
{
	bool operator()(const stroke& s) { return s.l.size() <= 4; }
};
struct emptySuperman : public unary_function<superman, void>
{
	bool operator()(const superman& tt) { return tt.ll.size() <=4; }
};

struct emptyYellow : public unary_function<yellow, void>
{
	bool operator()(const yellow& yy) { return yy.y.size() <=4; }
};

struct emptyGreen : public unary_function<green, void>
{
	bool operator()(const green& gg) { return gg.g.size() <=4; }
};

struct emptyBlue : public unary_function<blue, void>
{
	bool operator()(const blue& bb) { return bb.b.size() <=4; }
};

struct emptyIndigo : public unary_function<indigo, void>
{
	bool operator()(const indigo& indind) { return indind.ind.size() <=4; }
};

struct emptyViolet : public unary_function<violet, void>
{
	bool operator()(const violet& viovio) { return viovio.vio.size() <=4; }
};

void erase(const arVector3& v)
{
	lockDraw.lock();
	for_each(strokes.begin(), strokes.end(), eraseStroke(v));
	list<stroke>::iterator strokeIter = strokes.begin();
	while (strokeIter != strokes.end()){
		if ( (*strokeIter).l.size() <= 4 ){
			strokeIter = strokes.erase(strokeIter);
		}
		else{
			strokeIter++;
		}
	}
	
	strokes.splice(strokes.begin(), fragments);
	lockDraw.unlock();
}

void eraseO(const arVector3& vv)
{
	lockDraw.lock();
	for_each(batman.begin(), batman.end(), eraseStrokeO(vv));
	list<superman>::iterator strokeIterO = batman.begin();
	while (strokeIterO != batman.end()){
		if ( (*strokeIterO).ll.size() <= 4 ){
			strokeIterO = batman.erase(strokeIterO);
		}
		else{
			strokeIterO++;
		}
	}
	
	batman.splice(batman.begin(), riddler);
	lockDraw.unlock();
}

void eraseY(const arVector3& yy)
{
	lockDraw.lock();
	for_each(lineY.begin(), lineY.end(), eraseStrokeY(yy));
	list<yellow>::iterator strokeIterY = lineY.begin();
	while (strokeIterY != lineY.end()){
		if ( (*strokeIterY).y.size() <= 4 ){
			strokeIterY = lineY.erase(strokeIterY);
		}
		else{
			strokeIterY++;
		}
	}
	
	lineY.splice(lineY.begin(), fragmentY);
	lockDraw.unlock();
}

void eraseG(const arVector3& gg)
{
	lockDraw.lock();
	for_each(lineG.begin(), lineG.end(), eraseStrokeG(gg));
	list<green>::iterator strokeIterG = lineG.begin();
	while (strokeIterG != lineG.end()){
		if ( (*strokeIterG).g.size() <= 4 ){
			strokeIterG = lineG.erase(strokeIterG);
		}
		else{
			strokeIterG++;
		}
	}
	
	lineG.splice(lineG.begin(), fragmentG);
	lockDraw.unlock();
}

void eraseB(const arVector3& bb)
{
	lockDraw.lock();
	for_each(lineB.begin(), lineB.end(), eraseStrokeB(bb));
	list<blue>::iterator strokeIterB = lineB.begin();
	while (strokeIterB != lineB.end()){
		if ( (*strokeIterB).b.size() <= 4 ){
			strokeIterB = lineB.erase(strokeIterB);
		}
		else{
			strokeIterB++;
		}
	}
	
	lineB.splice(lineB.begin(), fragmentB);
	lockDraw.unlock();
}

void eraseInd(const arVector3& indind)
{
	lockDraw.lock();
	for_each(lineInd.begin(), lineInd.end(), eraseStrokeInd(indind));
	list<indigo>::iterator strokeIterInd = lineInd.begin();
	while (strokeIterInd != lineInd.end()){
		if ( (*strokeIterInd).ind.size() <= 4 ){
			strokeIterInd = lineInd.erase(strokeIterInd);
		}
		else{
			strokeIterInd++;
		}
	}
	
	lineInd.splice(lineInd.begin(), fragmentInd);
	lockDraw.unlock();
}

void eraseV(const arVector3& viovio)
{
	lockDraw.lock();
	for_each(lineV.begin(), lineV.end(), eraseStrokeV(viovio));
	list<violet>::iterator strokeIterV = lineV.begin();
	while (strokeIterV != lineV.end()){
		if ( (*strokeIterV).vio.size() <= 4 ){
			strokeIterV = lineV.erase(strokeIterV);
		}
		else{
			strokeIterV++;
		}
	}
	
	lineV.splice(lineV.begin(), fragmentV);
	lockDraw.unlock();
}

static enum { cursorDefault, cursorDraw, cursorErase } cursor;

void drawCursor(const arVector3& v)
{
	glDisable(GL_LIGHTING);
	glLineWidth(2);
	switch (cursor) {
			
		case cursorDefault:
			glColor3f(1,1,1);
			glPushMatrix();
			glTranslatef(v.v[0], v.v[1], v.v[2]);
			glutWireSphere(.1,6,6);
			glPopMatrix();
			break;
			
		case cursorDraw:
			glColor3f(.7,.7,.7);
			glPushMatrix();
			glTranslatef(v.v[0], v.v[1], v.v[2]);
			glutWireSphere(.1,6,6);
			glPopMatrix();
			glColor3f(1,1,1);
			glBegin(GL_LINES);
		{
			const GLfloat _ = 6.;
			glVertex3f(-_, v.v[1], v.v[2]);
			glVertex3f( _, v.v[1], v.v[2]);
			glVertex3f(v.v[0], 5.-_, v.v[2]);
			glVertex3f(v.v[0], 5.+_, v.v[2]);
			glVertex3f(v.v[0], v.v[1], -_);
			glVertex3f(v.v[0], v.v[1],  _);
		}
			glEnd();
			break;
			
		case cursorErase:
			if (a<1)
				glColor3f(1.,0,0);
			if (a>1 and a<2)
				glColor3f(1.,.5,0);
			if (a>2 and a<3)
				glColor3f(1.,1.,0);
			if (a>3 and a<4)
				glColor3f(0,1,0);
			if (a>4 and a<5)
				glColor3f(0,0,1);
			if (a>5 and a < 6)
				glColor3f(0,.5,.5);
			if (a>6)
				glColor3f(.5,0,.5);
			glPushMatrix();
			glTranslatef(v.v[0], v.v[1], v.v[2]);
			glutWireSphere(eraserRadius,8,8);
			glPopMatrix();
			break;
			
	}
	glEnable(GL_LIGHTING);
}

void audupdate(arMasterSlaveFramework& fw, const int* fDown, const arMatrix4& handmat){
    if(!fw.getMaster()) return;
    if(fDown[0]){
    AUDupdateSimpleFloats("loudness", 1, 0.8);
    AUDupdateSimpleFloats("pitch", 1, 2300.0);}
    if(fDown[1]){
    AUDupdateSimpleFloats("loudness", 1, 0.8);
    AUDupdateSimpleFloats("pitch", 1, 1500.0);}
    if(fDown[2]){
    AUDupdateSimpleFloats("loudness", 1, 4.0);
    AUDupdateSimpleFloats("pitch", 1, 5000.0);}
    if(!fDown[1] and !fDown[0] and !fDown[2]){
    AUDupdateSimpleFloats("loudness", 1, 0.0);}
 
}    

void update(const int* fDown, const arVector3& wand)
{
	static bool fDraw = false;
	static bool fErase = false;
	static bool fBoth = false;
        static bool fBam = false;
	static int fDownPrev[3] = {0};
	
	const bool fDrawBgn = fDown[0] && !fDownPrev[0] && !fErase;
	const bool fDrawEnd = !fDown[0] && fDownPrev[0] && !fErase;
	const bool fEraseBgn = fDown[1] && !fDownPrev[1] && !fDraw;
	const bool fEraseEnd = !fDown[1] && fDownPrev[1] && !fDraw;
	const bool Both = fDown[0] && fDown[1];
	//const bool Both = fDown[4];
        const bool Bam = fDown[2];

	if (Bam){
                fBam = true;
		glClearColor(0.5, 0.0, 0.0, 1.0);}

        if (fBam){
                strokes.clear();
		fragments.clear();
		batman.clear();
		riddler.clear();
		lineY.clear();
		fragmentY.clear();
		lineG.clear();
                fragmentG.clear();
		lineB.clear();
		fragmentB.clear();
		lineInd.clear();
		fragmentInd.clear();
		lineV.clear();
		fragmentV.clear();
		fBam=0;
}
	if (!fDown[0] and !fDown[2] and !fDown[1])
        glClearColor(0.0, 0.0, 0.0, 1.0);


	
	if (Both)
		fBoth = true;
	if (fBoth){
		if (g<15)
			g=g+.1;
		else
			g=0;
		fBoth=false;
	}
	
	if (fDrawBgn) {
		cursor = cursorDraw;
		sCur.clear();
		tCur.clear();
		yCur.clear();
		gCur.clear();
		bCur.clear();
		indCur.clear();
		vioCur.clear();
		fDraw = true;
	}
	if (fDraw)
		if (a<1){
		sCur.append(wand);}
	if (fDraw)
		if (a>1 and a<2){
		tCur.append(wand);}
	if (fDraw)
		if (a>2 and a<3){
		yCur.append(wand);}
	if (fDraw)
		if (a>3 and a<4){
		gCur.append(wand); }
	if (fDraw)
		if (a>4 and a<5){
		bCur.append(wand);}
	if (fDraw)
		if (a>5 and a<6){
		indCur.append(wand);}
	if (fDraw)
		if (a>6){
                vioCur.append(wand);}
	if (fDrawEnd) {
		lockDraw.lock();
		strokes.push_back(sCur);
		batman.push_back(tCur);
		lineY.push_back(yCur);
		lineG.push_back(gCur);
		lineB.push_back(bCur);
		lineInd.push_back(indCur);
		lineV.push_back(vioCur);
		lockDraw.unlock();
		sCur.clear();
		tCur.clear();
		yCur.clear();
		gCur.clear();
		bCur.clear();
		indCur.clear();
		vioCur.clear();
		cursor = cursorDefault;
		fDraw = false;
	}
	
	if (fEraseBgn) {
		cursor = cursorErase;
		fErase = true;
	}
	if (fErase) {
		erase(wand);
		eraseO(wand);
		eraseY(wand);
		eraseG(wand);
		eraseB(wand);
		eraseInd(wand);
		eraseV(wand);
		glClear(GL_COLOR_BUFFER_BIT);
		a = a+.07;
		if (a > 7) {
			a = 0;
		}
	}
	if (fEraseEnd) {
		cursor = cursorDefault;
		fErase = false;
	}
	
	memcpy(fDownPrev, fDown, sizeof(fDownPrev));
}



void postExchange(arMasterSlaveFramework& fw) {
	const int wandButton[3] = { fw.getButton(0), fw.getButton(1), fw.getButton(2) };
	update(wandButton, fw.getMatrix(1) * arVector3(0,0,-1)); 
        audupdate(fw, wandButton, fw.getMatrix(1));
}

#define USING_FEEDBACK
#ifdef USING_FEEDBACK
const int feedMax = 10000000; //;;overflow
GLfloat* feedBuffer = NULL;
#endif

void display(arMasterSlaveFramework& fw) {
	
#ifdef USING_FEEDBACK
	glFeedbackBuffer(feedMax, GL_3D_COLOR, feedBuffer);
	(void)glRenderMode(GL_FEEDBACK);
	drawSculpture();
	const int size = glRenderMode(GL_RENDER);
	
#endif
	if (a<9){
		drawSculptures();
		drawSculptureY();
		drawSculpture();
		drawSculptureG();
		drawSculptureB();
		drawSculptureInd();
		drawSculptureVio();
	}
	
	drawStars();
	drawCursor(fw.getMatrix(1) * arVector3(0,0,-1));
	
}

void die_sound(arMasterSlaveFramework& fw){ 
    if(!fw.getMaster()) return;
    EndSoundServer();}

int main(int argc, char** argv){
#ifdef USING_FEEDBACK
	feedBuffer = new GLfloat[feedMax];
#endif
	arMasterSlaveFramework fw;
	fw.setStartCallback(init);
	fw.setPostExchangeCallback(postExchange);
        fw.setExitCallback(die_sound);
	fw.setDrawCallback(display);
	return fw.init(argc, argv) && fw.start() ? 0 : 1;
}
